function fl=BVPfplot(PROBLEM,SOLVER,indsol,flout,PATH)
% Plot of the solution computed by the solver.
% 
% 
%  INPUT 
%     PROBLEM : name of the IVPtestset problem
%     SOLVER  : name of the IVPtestste solver
%     indsol  : index of the printed component defined in the function
%               setoutput
%     flout   : optional : flag = 1 the eps file are printed
%                                 0 (default) no  eps output
%     PATH    : optional : location of the input data file
%
%  OUTPUT
%     fl      : flag = 0 normal return
%     
%---------------------------------------------------------------------
%
%     This file is part of the Test Set for BVP solvers
%     http://www.dm.uniba.it/~bvpsolvers/
%
% 
%     DISCLAIMER: see
%     http://www.dm.uniba.it/~bvpsolvers/testsetbvpsolvers/?page_id=34
%
%     The most recent version of this source file can be found at
%     http://www.dm.uniba.it/~bvpsolvers/bvpTestSet/tests/BVPfplot.m
%
%
%     This is revision
%     $Id: IVPfplot.m,v 1.5 2006/10/06 11:51:25 testset Exp $
%-----------------------------------------------------------------------
fl = 0;
if nargin < 3
    fl = 1;
    error('The input parameters are: PROBLEM, SOLVER, ind')
end
if nargin < 4
    flout = 0;
end
if nargin < 5
    PATH='';
end
nfile = strcat(lower(PROBLEM),'_',upper(SOLVER),'.txt');
ndata=load(nfile);
nind = length(indsol);
for i=1:nind
  figure(i)
  plot(ndata(:,1),ndata(:,i+1))
  set(gca,'FontSize',14)
  title(sprintf('PROBLEM= %s, SOLVER = %s, component = %g ',PROBLEM,SOLVER,indsol(i))) 
  
  if flout
     epsfile = sprintf('%s%s%s_%g',PATH,PROBLEM,SOLVER,i);
     print(gcf,'-depsc2',epsfile)
  end
end
