#
#     This file is part of the Test Set for BVP solvers
#     http://www.dm.uniba.it/~bvpsolvers/
#
#       R file to plot the computed solution
#       change the directory to the directory tests before to run it
#
#     DISCLAIMER: see
#     http://www.dm.uniba.it/~bvpsolvers/testsetbvpsolvers/?page_id=34
#
#     The most recent version of this source file can be found at
#     http://www.dm.uniba.it/~bvpsolvers/bvpTestSet/tests/BVPfplot.R
#


BVPfplot = function(PROBLEM,SOLVER,indsol,flout,PATH)
{
   fl = 0
   options(digits = 12)
   
   nargin <- length(as.list(match.call())) -1 #function "nargin" Matlab like
   if (nargin < 3)
   {
     fl = 1
     error('The input parameters are: PROBLEM, SOLVER, ind')
   }
   if (nargin < 4)
     flout = 0
   if (nargin < 5) 
     PATH=""

   
   
   file = paste(PATH, PROBLEM,"_", SOLVER, ".txt", sep = "")
   values <- read.table(file) #function "load" Matlab like
   nind = length(indsol)

   for (i in 1 : nind)
   {
      
      if(flout)
      {
	      #pngfile = sprintf('%s%s%s%g',PATH,PROBLEM,SOLVER,i)
        #png(paste(pngfile, ".png", sep = "")) #it's possible to use others devices like png(...), or postscript
        plot(values[,1],values[,i+1], xlab = "x", ylab = "y" ,col="darkblue", type = "l") #pch=number for a different shape, type = "l" for line
        title(sprintf('PROBLEM= %s, SOLVER = %s, i = %g ',PROBLEM,SOLVER,indsol[i]))#or main = title inserts title into the plot(...) 
        browser()
	      #dev.off() #allow to save  
      }
      
   }



   return(fl)
}

